module Food
    class Menu
        attr_reader :name, :descripcion_menu, :precio_menu, :platos
        def initialize(name, &block)
            @name = name
            @descripcion_menu = ""
            @platos = []
            @precio_menu = 0

            if block_given?  
                if block.arity == 1
                  yield self
                else
                 instance_eval(&block) 
                end
            end
        end

        def descripcion(name)
            @descripcion_menu = name
        end

        def componente(options = {})
            plate = {}
            plate[:plato] = options[:objeto]
            plate[:precio] = options[:precio]
            @platos << plate
        end
        
        def precio(amount)
            @precio_menu = amount
        end

        def to_s
            aux = "Nombre del Menú: #{@name}"
            aux += "\nDescripción: #{@descripcion_menu}"
            aux += "\nComponentes: "
            @platos.each { |val| 
                if val[:plato].use == nil
                    val[:plato].plato()
                end
                aux += "\n\t#{val[:plato].name}" 
                aux += "\n\t\tPrecio: #{val[:precio]}"
                aux += "\n\t\tValor Nutricional: #{val[:plato].use.VCT()}"
                aux += "\n\t\tValores Ambientales:"
                aux += "\n\t\t\tCO2: #{val[:plato].use.daily_co2}"
                aux += "\n\t\t\tGround Use: #{val[:plato].use.ground_use_plate}"
            }
            aux += "\nPrecio Menú: #{@precio_menu}"
        end
    end
end