module Food
    class PlateDSL 
        require "food"
        attr_reader :name, :descripcion_plato, :food, :food_gr, :food_aux, :use
        def initialize(name, &block)
            @name = name
            @descripcion_plato = ""
            @food
            @food_aux = []
            @food_gr = [] 
            @use

            if block_given?  
                if block.arity == 1
                  yield self
                else
                 instance_eval(&block) 
                end
            end
        end

        def nombre(full_name)
            @descripcion_plato = full_name
        end

        def alimento(options = {})
            @food_aux << options[:objeto]
            @food_gr << options[:gramos]
        end

        def to_s
            if @use == nil
                plato()
            end
            aux = "Nombre Plato: #{@descripcion_plato}\n"
            aux += "Alimentos: "
            i = 0
            food.each { |val| aux += "\n\t" + val.value.name 
                        aux += "\n\t\tGramos: #{food_gr[i]}"
                        i += 1
            }
            aux += "\nCalorías del Plato: #{@use.VCT()}"
            aux += "\nValores ambientales:"
            aux += "\n\tCO2: #{@use.daily_co2}"
            aux += "\n\tGround Use: #{@use.ground_use_plate}"
            return aux
        end

        def plato 
            @food = List.new(@food_aux[0])
            for i in (1..@food_aux.length - 1)
                @food.insert_head(@food_aux[i])
            end
            @use = PlateAmbiental.new(name, food, food_gr)
        end
    end
end